local myname="ZifnabsOutfitter"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={outfitter=Me} else ZifnabsMod.outfitter=Me end
local mod
local L
local C
local db
local PLAYERNAME=UnitName("player").." "..GetRealmName()
local slots={AMMO=0,HEAD=1,NECK=2,SHOULDER=3,SHIRT=4,CHEST=5,WAIST=6,LEGS=7,FEET=8,WRIST=9,HANDS=10,FINGER1=11,FINGER2=12,TRINKET1=13,TRINKET2=14,BACK=15,MAINHAND=16,OFFHAND=17,RANGED=18,TABARD=19,CLOAK=-1,HELM=-2}
local lastoutfit=nil
local outfitchangetime=0
local widget={}
local now=0

-- TODO: Outfitwechsel im Kampf sperren

-- Slash Commands
SLASH_ZIFNABSOUTFITTER1 = "/zo"
SlashCmdList["ZIFNABSOUTFITTER"]=function (parm) Me:Command(parm) end

-- --------------------------------------------------------------------------------------
-- INITIALIZE
-- --------------------------------------------------------------------------------------
function Me:Initialize(fwinfo)
	mod=fwinfo.mod
	L=fwinfo.L
	C=fwinfo.C
	db=fwinfo.db
	if not db.outfitter then db.outfitter={outfit={},current={}} end
	if not db.outfitter.outfit[PLAYERNAME] then db.outfitter.outfit[PLAYERNAME]={NORMAL={camel="Normal"}} end
	widget.select=mod.ui:newControlButton(3,myname.."_Select",{click=Me.Click})
	mod.core:Register4Event("ONUPDATE","outfitter",Me.OnUpdate)
end

-- --------------------------------------------------------------------------------------
-- ON UPDATE
-- --------------------------------------------------------------------------------------
function Me:OnUpdate(elapsed)
	now=now+elapsed
	local outfitname=db.outfitter.current[PLAYERNAME] or "NORMAL"
	local outfit=db.outfitter.outfit[PLAYERNAME][outfitname]
	if outfit and outfit~=lastoutfit then
		widget.select:SetText(string.lower(string.sub(outfitname,1,1)))
		widget.select.tooltipText=L.word.outfit.." "..outfit.camel
		outfitchangetime=now
	elseif outfit and outfit==lastoutfit and now-outfitchangetime>0.5 then
		for slot,id in pairs(slots) do
			if id>=0 then
				local slotequip=GetInventoryItemID("player",id)
				local coutfit=outfit
				local coutfitname=outfitname
				if outfit[slot] and outfit[slot].ignore then
					coutfit=db.outfitter.outfit[PLAYERNAME].NORMAL
					coutfitname="NORMAL"
				end
				if not coutfit[slot] or (coutfit[slot].item~=slotequip) then
					if not coutfit[slot] then coutfit[slot]={item=slotequip}
					else coutfit[slot].item=slotequip end
					mod.f:PrintR(L.msg.outfitchanged,{outfit=coutfit.camel,slot=slot,item=Me:ItemName(slotequip) or L.word.nothing})
				end
			end
		end
	end
	lastoutfit=outfit
end

-- --------------------------------------------------------------------------------------
-- EXISTS IN BAG?
-- --------------------------------------------------------------------------------------
function Me:ExistsInBags(item)
	local found=false
	for bag=0,4,1 do
		for slot=1,40,1 do found=found or (GetContainerItemID(bag,slot)==item) end
	end
	return found
end

-- --------------------------------------------------------------------------------------
-- WEAR
-- --------------------------------------------------------------------------------------
function Me:Wear(outfitname)
	local uoutfitname=string.upper(outfitname)
	if db.outfitter.current[PLAYERNAME]==uoutfitname then nop=nil --nothing
	elseif mod.f:InFight() then mod.f:Print(L.msg.nochangeinfight,"buzzer.mp3")
	elseif mod.gatherer:IsFishing() then mod.f:Print(L.msg.nochangewhilefishing,"buzzer.mp3")
	else
		local outfit=db.outfitter.outfit[PLAYERNAME][uoutfitname] or {camel=outfitname}
		if not db.outfitter.outfit[PLAYERNAME][uoutfitname] then db.outfitter.outfit[PLAYERNAME][uoutfitname]=outfit end
		local freeslots={[0]=0,[1]=0,[2]=0,[3]=0,[4]=0}
		for bag=0,4,1 do
			for slot=1,GetContainerNumSlots(bag),1 do 
				if not GetContainerItemID(bag,slot) then freeslots[bag]=freeslots[bag]+1 end
			end
		end
		for slot,id in pairs(slots) do
			local slotequip=GetInventoryItemID("player",id)
			if not outfit[slot] then outfit[slot]={} end
			local shallequip=outfit[slot].item
			if outfit[slot].ignore then shallequip=db.outfitter.outfit[PLAYERNAME]["NORMAL"][slot].item end
			local itemname=Me:ItemName(shallequip)			
			if id>=0 and shallequip~=slotequip then
				if slotequip and not shallequip then
					local usebag=nil
					for bag=4,0,-1 do
						if freeslots[bag]>0 and not usebag then
							usebag=bag
							freeslots[bag]=freeslots[bag]-1
						end
					end
					if not usebag then mod.f:PrintR(L.msg.noroomfor,{outfit=outfit.camel,slot=slot})
					else
						if usebag==0 then
mod.f:PrintR(L.msg.noroomfor,{outfit=outfit.camel,slot=slot})						
--							PickupInventoryItem(id)
--							PutItemInBagpack()
						else
							PickupInventoryItem(id)
							PutItemInBag(usebag+19)
						end
					end
				elseif Me:ExistsInBags(shallequip)==true then
					EquipItemByName(itemname,id)
				else 
					if itemname then mod.f:PrintR(L.msg.itemnotfound,{outfit=outfit.camel,slot=slot,item=itemname}) end
				end
			end
		end
		if outfit["HELM"] and outfit["HELM"].ignore then ShowHelm(false) else ShowHelm(true) end
		if outfit["CLOAK"] and outfit["CLOAK"].ignore then ShowCloak(false) else ShowCloak(true) end
		if uoutfitname~=db.outfitter.current[PLAYERNAME] then mod.f:PrintR(L.msg.nowwearing,{outfit=outfit.camel}) end
		db.outfitter.current[PLAYERNAME]=uoutfitname
	end
end

-- --------------------------------------------------------------------------------------
-- IGNORE
-- --------------------------------------------------------------------------------------
function Me:Ignore(outfitname,slot,truefalse)
	local outfit=db.outfitter.outfit[PLAYERNAME][outfitname]
	if not outfit then mod.f:PrintR(L.msg.unknownoutfit,{outfit=outfitname})
	else
		for oneslot,slotnr in pairs(slots) do
			if not outfit[oneslot] then outfit[oneslot]={} end
			if slot=="ALL" or oneslot==slot then 
				outfit[oneslot].ignore=truefalse
				Me:List(outfitname,oneslot)
			end
		end
	end
end

-- --------------------------------------------------------------------------------------
-- LIST
-- --------------------------------------------------------------------------------------
function Me:List(outfitname,slot)
	local outfit=db.outfitter.outfit[PLAYERNAME][outfitname]
	if not outfit then mod.f:PrintR(L.msg.unknownoutfit,{outfit=outfitname})
	else
		for oneslot,slotnr in pairs(slots) do
			if not outfit[oneslot] then outfit[oneslot]={} end
			local use="+"
			if outfit[oneslot].ignore then use="-" end
			if slotnr>=0 and (slot=="ALL" or oneslot==slot) then
				mod.f:PrintR("<outfit> <use> <slot>: <item>",{use=use,outfit=outfit.camel,slot=oneslot,item=Me:ItemName(outfit[oneslot].item) or L.word.nothing,ignore=ignore})
			end
		end
		if slot=="ALL" or slot=="HELM" then 
			if outfit["HELM"].ignore==true then mod.f:PrintR(L.msg.showhelm,{pm="-"}) else mod.f:PrintR(L.msg.showhelm,{pm="+"}) end 
		end
		if slot=="ALL" or slot=="CLOAK" then 
			if outfit["CLOAK"].ignore==true then mod.f:PrintR(L.msg.showcloak,{pm="-"}) else mod.f:PrintR(L.msg.showcloak,{pm="+"}) end 
		end
	end
end

-- --------------------------------------------------------------------------------------
-- ITEM NAME
-- --------------------------------------------------------------------------------------
function Me:ItemName(itemid)
	if not itemid then return nil end
	local itemname=GetItemInfo(itemid)
	return itemname
end

-- --------------------------------------------------------------------------------------
-- COMMAND
-- --------------------------------------------------------------------------------------
function Me:Command(cmd)
	local parse=mod.f:Split(cmd," ")
	local cmd=string.upper(parse[1] or "")
	local slot=string.upper(parse[2] or "ALL")
	local outfit=parse[3] or db.outfitter.current[PLAYERNAME] or "Normal"
	if cmd=="WEAR" then Me:Wear(parse[2] or "Normal")
	elseif cmd=="LIST" then Me:List(string.upper(outfit),slot)
	elseif cmd=="IGNORE" then Me:Ignore(string.upper(outfit),slot,true)
	elseif cmd=="UNIGNORE" then Me:Ignore(string.upper(outfit),slot,false)
	elseif (cmd=="SHOW" or cmd=="HIDE") and slot=="CLOAK" then
		Me:Ignore(string.upper(outfit),"CLOAK",(cmd=="HIDE"))
		ShowCloak(cmd=="SHOW")
	elseif (cmd=="SHOW" or cmd=="HIDE") and slot=="HELM" then
		Me:Ignore(string.upper(outfit),"HELM",(cmd=="HIDE"))
		ShowHelm(cmd=="SHOW")
	else mod.f:PrintR(L.msg.unknowncmd,{cmd=cmd}) end
end

-- --------------------------------------------------------------------------------------
-- CLICK
-- --------------------------------------------------------------------------------------
function Me:Click(button,parse)
	if button.outfit then Me:Wear(button.outfit) end
	if button.outfit or parse[#parse]=="Select" then
		if not widget.list then widget.list={} end
		widget.select.showing=not widget.select.showing
		if not widget.select.showing then
			for n,btn in pairs(widget.list) do btn:Hide() end
		else
			local nr=0
			for uoutfitname,outfit in pairs(db.outfitter.outfit[PLAYERNAME]) do
				if not widget.list[nr] then
					widget.list[nr]=mod.ui:newButton(myname,80,16,widget.select,"TOPLEFT","TOPRIGHT",0,-16*nr,{click=Me.Click})
				end
				widget.list[nr].outfit=outfit.camel
				widget.list[nr]:SetText(outfit.camel)
				widget.list[nr]:Show()
				nr=nr+1
			end
		end
	end
end