local myname="ZifnabsScheduler"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={scheduler=Me} else ZifnabsMod.scheduler=Me end
local mod
local L
local db

local online=0
local tick=0
local fps={min=40,max=60,value=0,update=0}
local widget={}
local schedule={[1]={at=9999999999,id=nil,script=nil}}
local remind={id=0}

-- bandwidthInKB, bandwidthOutKB, latencyHomeMS, latencyWorldMS = GetNetStats()

-- --------------------------------------------------------------------------------------
-- INITIALIZE
-- --------------------------------------------------------------------------------------
function Me:Initialize(fwinfo)
	ZifnabsFW=fwinfo
	mod=fwinfo.mod
	L=fwinfo.L
	db=fwinfo.db
	
	widget.fpstext=mod.ui:addText(myname.."_FPS_Text",32,10,fwinfo.frame,"TOPRIGHT","TOPRIGHT",-4,-6,11,"RIGHT")
	
	mod.core:Register4Event("ONUPDATE","scheduler",Me.OnUpdate)
end

-- --------------------------------------------------------------------------------------
-- ON UPDATE
-- --------------------------------------------------------------------------------------
function Me:OnUpdate(elapsed)
	online=online+elapsed
	if online>=tick+0.1 then 
		mod.core:OnEvent("TICK",online-tick,online) 
		tick=online
	end

	if schedule[1].at<=time() then
		local command=schedule[1].script
		tremove(schedule,1)
		local command=gsub(command or "","[*][.]mod[.]","ZifnabsFW.mod.")
		local command=gsub(command or "","[*][.]L[.]","ZifnabsFW.L.")
		assert(loadstring(command))()
	end

	-- show FPS
	if online>=fps.update+1 then
		local colorrange=(fps.max-fps.min)/2
		local red=min(colorrange,max(0,fps.max-fps.value))/colorrange
		local green=min(colorrange,max(0,fps.value-fps.min))/colorrange
		widget.fpstext:SetText(fps.value)
		widget.fpstext:SetTextColor(red,green,0,1)
		fps.value=0
		fps.update=online
	end
	fps.value=fps.value+1	
end

-- --------------------------------------------------------------------------------------
-- ADD
-- --------------------------------------------------------------------------------------
function Me:add(after,id,script)
	local at=time()+after
	for i=1,999,1 do
		if schedule[i] and schedule[i].id==id then tremove(schedule,i) end
	end
	for i=1,999,1 do
		if schedule[i].at>at then
			tinsert(schedule,i,{at=at,id=id,script=script})
			break
		end
	end
end

-- --------------------------------------------------------------------------------------
-- REMIND
-- --------------------------------------------------------------------------------------
function Me:Remind(seconds,text)
	Me:add(seconds,"R"..time(),"*.mod.hud:write(\""..text.."\",\"dingding.mp3\")")
end

function Me:list()
	for i=1,999,1 do
		if schedule[i].at>=9999999999 then break end
		if schedule[i] then mod.f:Print(i..": "..(schedule[i].at-time()).." id="..(schedule[i].id or "nil")..": "..(schedule[i].script or "nil"))
		else mod.f:Print(i..": unexistant entry") end
	end
	mod.f:Print(L.msg.endoflist)
end